# `rahrah`
[![DOI](https://zenodo.org/badge/894175735.svg)](https://doi.org/10.5281/zenodo.14300869)

University-inspired matplotlib color palettes and colormaps. Colors are taken directly from University branding guidelines, so there is no specific effort toward perceptual uniformity or accessibility for color blindness beyond the aesthetic choices I made in putting the palettes/colormaps together. Please check your plots/figures with [COBLIS](https://www.color-blindness.com/coblis-color-blindness-simulator/) or similar.

## Installation
To install:
```bash
cd ~

git clone git@github.com:avapolzin/rahrah.git

cd rahrah

sudo python3 setupy.py install

````
or 
```bash
pip install rahrah
```

If you use this package or the scripts in this repository in a publication, please add a footnote linking to https://github.com/avapolzin/rahrah and/or consider adding this software to your acknowledgments. If you would like to cite `rahrah`, please use the Zenodo DOI linked here. 

```tex
@software{polzin_2024_14300870,
  author       = {Polzin, Ava},
  title        = {rahrah: University-inspired matplotlib color
                   palettes and colormaps
                  },
  month        = dec,
  year         = 2024,
  publisher    = {Zenodo},
  version      = {v0.2},
  doi          = {10.5281/zenodo.14300870},
  url          = {https://doi.org/10.5281/zenodo.14300870}
  swhid        = {swh:1:dir:f5517cf3ee10e03d2c923acbd60ed486ecd5c5ed
                   ;origin=https://doi.org/10.5281/zenodo.14300869;vi
                   sit=swh:1:snp:2d43321672bb3a4c51509ddeb4bf5b0140bf
                   a2cc;anchor=swh:1:rel:5dc42309dc4c017dde7bd8f68ed1
                   f12e49e8b584;path=/
                  },
}
```


I'd love to feature plots/figures that make use of these palettes in the wild, so should these palettes be of use, please send me a copy of that figure and/or a link to your paper or presentation and I will share it here.

(Interested in palettes and colormaps based on album covers? Check out [`albumpl`](https://github.com/avapolzin/albumpl).)

## Palettes/Colormaps
To request the addition of a new school's palette/colormap, please open an issue, linking to the university's branding guidelines.

Included palettes (to now):

1. __Brown__ (Brown University)
![Brown_summary](https://github.com/user-attachments/assets/1ae000dd-3efe-4966-bf2b-68c7b229c100)

2. __BrownBright__ (Brown University)
![BrownBright_summary](https://github.com/user-attachments/assets/87f50a5d-ff85-4375-bf18-8c1307552da7)

3. __Caltech__ (California Institute of Technology)
![Caltech_summary](https://github.com/user-attachments/assets/671f0a87-fd52-41bd-9201-45c319c278a5)

4. __CaltechBright__ (California Institute of Technology)
![CaltechBright_summary](https://github.com/user-attachments/assets/3d6dea8e-1e07-4b13-8a0b-afa4e1e2d458)

5. __CarnegieMellon__ (Carnegie Mellon University)
![CarnegieMellon_summary](https://github.com/user-attachments/assets/e24a0d04-11b2-4b1f-8805-040c66135ebd)

6. __CarnegieMellonBright__ (Carnegie Mellon University)
![CMUBright_summary](https://github.com/user-attachments/assets/00a49320-c3cd-41b3-915c-e420879cda15)

7. __Columbia__ (Columbia University)
![Columbia_summary](https://github.com/user-attachments/assets/fead0f1e-4962-4f2f-81d4-8e6c7d99195f)

8. __ColumbiaBright__ (Columbia University)
![ColumbiaBright_summary](https://github.com/user-attachments/assets/e7f81f93-5b4b-4ffc-903b-047c98085884)

9. __Cornell__ (Cornell University)
![Cornell_summary](https://github.com/user-attachments/assets/f5552a73-79b6-49bd-a9f0-0b0b9a0e1b69)

10. __Dartmouth__ (Dartmouth College)
![Dartmouth_summary](https://github.com/user-attachments/assets/a142ffef-6d51-4158-8b5e-fef778715a0e)

11. __DartmouthMono__ (Dartmouth College)
![DartmouthMono_summary](https://github.com/user-attachments/assets/7a4bb210-98f2-426f-bc0e-afc43be58a1c)

12. __Duke__ (Duke University)
![Duke_summary](https://github.com/user-attachments/assets/eb1e8210-dd0c-47bc-ad06-18fb6602307c)

13. __Harvard__ (Harvard University)
![Harvard_summary](https://github.com/user-attachments/assets/59cbd068-fca3-4174-8408-efb1aa3bdae5)

24. __Indiana__ (Indiana University)
![Indiana_summary](https://github.com/user-attachments/assets/aab0f896-43a6-499e-a12a-fea5c31ebe69)

15. __JohnsHopkins__ (Johns Hopkins University)
![JohnsHopkins_summary](https://github.com/user-attachments/assets/62c3807c-76eb-4c52-a2b4-302176af479a)

16. __JohnsHopkinsMono__ (Johns Hopkins University)
![JohnsHopkinsMono_summary](https://github.com/user-attachments/assets/0a1b5e4b-783f-4b1a-8268-575d3dadba31)

17. __MIT__ (Massachusetts Institute of Technology)
![MIT_summary](https://github.com/user-attachments/assets/6a3f1e30-e3ac-4579-bdf7-148c25f2a161)

18. __MITBright__ (Massachusetts Institute of Technology)
![MITBright_summary](https://github.com/user-attachments/assets/82854069-eb1f-4015-bca6-3f924385c930)

19. __MichiganState__ (Michigan State University)
![MichiganState_summary](https://github.com/user-attachments/assets/784f61a6-a490-464f-9294-2735f32af0ae)

20. __Northwestern__ (Northwestern University)
![Northwestern_summary](https://github.com/user-attachments/assets/bd55ef2f-40e2-4033-9730-544d99b22706)

21. __Princeton__ (Princeton University)
![Princeton_summary](https://github.com/user-attachments/assets/fa0d2271-d804-4e69-9cfe-3063de16cbb0)

22. __Stanford__ (Stanford University)
![Stanford_summary](https://github.com/user-attachments/assets/8deec9c0-fa13-4e43-9bb5-cf121536ba69)

23. __Berkeley__ (University of California, Berkeley)
![Berkeley_summary](https://github.com/user-attachments/assets/b61e0278-82db-4998-a4c0-d5c53d0c5cc8)

24. __UCLA__ (University of California, Los Angeles)
![UCLA_summary](https://github.com/user-attachments/assets/8faf841e-0f27-47cb-b340-82bdf97f61f8)

25. __Cambridge__ (University of Cambridge)
![Cambridge_summary](https://github.com/user-attachments/assets/bc9e73b1-c4cf-4a9a-9e1d-ecaa64b0e24b)

26. __Chicago__ (The University of Chicago)
![chicago_summary](https://github.com/user-attachments/assets/b432a9b3-47a4-4e33-831b-6ae4c4c5ac18)

27. __ChicagoBright__ (The University of Chicago)
![ChicagoBright_summary](https://github.com/user-attachments/assets/f928272c-ecfd-4223-bff1-0c0a075f174e)

28. __Colorado__ (University of Colorado Boulder)
![Colorado_summary](https://github.com/user-attachments/assets/ae2bab4b-24dc-49ce-b6b4-d7ae5dc70815)

29. __Illinois__ (University of Illinois)
![Illinois_summary](https://github.com/user-attachments/assets/8dcdb960-58c4-46f0-95b8-eca23dc49d1f)

30. __Iowa__ (University of Iowa)
![Iowa_summary](https://github.com/user-attachments/assets/40b5cea6-9ae8-448b-9cd3-1bf0fd85742f)

31. __Oxford__ (University of Oxford)
![Oxford_summary](https://github.com/user-attachments/assets/2829ee7e-05a2-4ed9-90a8-c39dada8fc96)

32. __Maryland__ (University of Maryland)
![Maryland_summary](https://github.com/user-attachments/assets/bfe5bbff-ef68-48fe-894a-d2ff1419f991)

33. __UMass__ (University of Massachusetts Amherst)
![UMass_summary](https://github.com/user-attachments/assets/af7f0fbb-1b18-4150-bde7-cb27aeb23921)

34. __UMassBright__ (University of Massachusetts Amherst)
![UMassBright_summary](https://github.com/user-attachments/assets/31e4f542-4413-4a96-a476-b1de32e48cce)

35. __Michigan__ (University of Michigan)
![Michigan_summary](https://github.com/user-attachments/assets/d27b0b10-7032-4ddc-b71a-1320e02c0967)

36. __Minnesota__ (University of Minnesota)
![Minnesota_summary](https://github.com/user-attachments/assets/3ceec51f-9190-4e0a-97a4-f31306f01995)

37. __UNC__ (University of North Carolina Chapel Hill)
![UNC_summary](https://github.com/user-attachments/assets/827af657-1152-44d4-82ba-034f732448b0)

38. __UNCBright__ (University of North Carolina Chapel Hill)
![UNCBright_summary](https://github.com/user-attachments/assets/ec4eaafd-3329-4c64-80d4-d137e344be27)

39. __Penn__ (University of Pennsylvania)
![Penn_summary](https://github.com/user-attachments/assets/7e7d6c84-6e71-4142-8ccc-c3b40627555c)

40. __USC__ (University of Southern California)
![USC_summary](https://github.com/user-attachments/assets/59e6bbcb-7dfd-4079-9d57-66c9eddcf463)

41. __Texas__ (University of Texas)
![Texas_summary](https://github.com/user-attachments/assets/ebdefefa-65d4-4f05-b7b5-5853db47788c)

42. __Toronto__ (University of Toronto)
![Toronto_summary](https://github.com/user-attachments/assets/b5de86fd-5959-4420-afc0-b1ec05265f1d)

43. __Yale__ (Yale University)
![yale_summary](https://github.com/user-attachments/assets/6a52ff2c-4465-453f-a9b5-943d94d47a3f)

There are also some alternative colormaps that are not the default associated with a specific palette, but are still callable.
  
<img src="https://github.com/user-attachments/assets/e7c2a57c-b297-4e8d-aec3-c9cdc55c364f" width="30%"><img src="https://github.com/user-attachments/assets/d76d8d34-b4dd-4c64-9d07-6a7d58d5611b" width="30%"><img src="https://github.com/user-attachments/assets/94ba5e48-cf95-4c33-92ea-e94a275f3cfb" width=30%><img src="https://github.com/user-attachments/assets/609dbe5d-d4b5-4bd8-8612-5aee6f04492e" width="30%"><img src="https://github.com/user-attachments/assets/b80d03d0-23f0-45f0-8836-b2a7f60b325f" width="30%"><img src="https://github.com/user-attachments/assets/0554f089-0473-4405-89cc-0b912f0776ad" width="30%"><img src="https://github.com/user-attachments/assets/b4513bc6-157e-4eb1-9f0f-940c025361d4" width=30%><img src="https://github.com/user-attachments/assets/b06017bd-e405-451f-b3cd-604ae0ac493b" width=30%>

*** 
## How to use `rahrah`:

- **To list all palettes and their properties:**
```python
from rahrah.palette import list_palettes

list_palettes()
```
*You can also filter for number of colors in the color cycle or type of colormap (sequential/diverging) with the arguments `mincolors` and `maptype`.*

- **To list all colormaps:**
```python
from rahrah.cmap import list_maps

list_maps()
```

- **To set palette as default for both color cycle *and* colormap:**
```python
from rahrah.palette import set_default

set_default('Northwestern')
```

- **To set a palette as default for color cycle *or* colormap:**
```python
from rahrah.palette import set_default_ccyle, set_default_cmap

set_default_ccyle('ChicagoBright')
```
*or*
```python
set_default_cmap('Yale')
```

- **To access colormaps without setting them as default:**

```python
import matplotlib.pyplot as plt
from rahrah.cmap import * #yes, this is bad practice, but easiest in this case!

plt.imshow(image, cmap = 'USC')
```
To reverse the colormap, simply append '_r' to the name (e.g., 'USC' becomes 'USC_r').

- **To access the colors in a color cycle/palette without setting a default:**
```python
from rahrah.palette import return_colors

return_colors('BrownBright')
```

The lightness of all colormaps is shown below (all sequential maps are shown dark-to-light for easier comparison):
![rahrahlightness 001](https://github.com/user-attachments/assets/ed734692-9ee7-4500-bf25-4e97af3af455)
